library ieee; 
use ieee.std_logic_1164.all; 
use ieee.std_logic_arith.all; 
use ieee.std_logic_unsigned.all; 
package rijndael_package1 is
subtype STATE_TYPE is std_logic_vector(255 downto 0);
subtype SLV_16 is std_logic_vector(15 downto 0); 
subtype SLV_256 is std_logic_vector(255 downto 0);
subtype SLV_8 is std_logic_vector(7 downto 0); 
subtype round_type is integer range 0 to 16; 
function MIX_COLUMN_FUNCT (state: STATE_TYPE) 
return STATE_TYPE; 
function POLY_MULTE_FUNCT (a: SLV_16; b: SLV_16)
return SLV_16;
end package rijndael_package1;

package body rijndael_package1 is
function MIX_COLUMN_FUNCT (state: STATE_TYPE) return
STATE_TYPE is 

variable t0: SLV_16; 
variable t1: SLV_16; 
variable t2: SLV_16; 
variable t3: SLV_16; 
variable t4: SLV_16; 
variable t5: SLV_16; 
variable t6: SLV_16; 
variable t7: SLV_16; 
variable t8: SLV_16; 
variable t9: SLV_16; 
variable t10: SLV_16; 
variable t11: SLV_16; 
variable t12: SLV_16; 
variable t13: SLV_16; 
variable t14: SLV_16; 
variable t15: SLV_16; 
variable DATAOUT: SLV_256; 
variable temp: SLV_256; 
begin 
t0 := state(255 downto 240); 
t1 := state(239 downto 224); 
t2 := state(223 downto 208); 
t3 := state(207 downto 192); 
t4 := state(191 downto 176); 
t5 := state(175 downto 160); 
t6:= state(159 downto 144); 
t7 := state(143 downto 128); 
t8 := state(127 downto 112); 
t9 := state(111 downto 96); 
t10 := state(95 downto 80); 
t11:= state(79 downto 64); 
t12 := state(63 downto 48); 
t13 := state(47 downto 32); 
t14 := state(31 downto 16); 
t15 := state(15 downto 0); 

DATAOUT(240 downto 240) := POLY_MULTE_FUNCT("0000000000000010", t0) xor
POLY_MULTE_FUNCT("0000000000000011", t1) xor
t2 xor t3; 
DATAOUT(239 downto 224) := t0 xor POLY_MULTE_FUNCT("0000000000000010", t1) 
xor POLY_MULTE_FUNCT("0000000000000011", t2) 
xor t3; 
DATAOUT(223 downto 208) := POLY_MULTE_FUNCT("0000000000000010" , t2) xor
POLY_MULTE_FUNCT("0000000000000011", t3) xor
t0 xor t1; 
DATAOUT(207 downto 192) := POLY_MULTE_FUNCT("0000000000000011" , t0) xor
POLY_MULTE_FUNCT("0000000000000010", t3) xor
t1 xor t2; 
DATAOUT(191 downto 176) := POLY_MULTE_FUNCT("0000000000000010" , t4) xor 
POLY_MULTE_FUNCT("0000000000000011", t5) xor
t6 xor t7; 
DATAOUT(175 downto 160) := POLY_MULTE_FUNCT("0000000000000010" , t5) xor
POLY_MULTE_FUNCT("0000000000000011" , t6) xor
t4 xor t7; 
DATAOUT(159 downto 144) := POLY_MULTE_FUNCT("0000000000000010" , t6) xor
POLY_MULTE_FUNCT("0000000000000011", t7) xor
t4 xor t5; 
DATAOUT(143 downto 128) := POLY_MULTE_FUNCT("0000000000000011" , t4) xor
POLY_MULTE_FUNCT("0000000000000010", t7) xor
t5 xor t6; 
DATAOUT(127 downto 112) := POLY_MULTE_FUNCT("0000000000000010", t8) xor
POLY_MULTE_FUNCT("0000000000000011", t9) xor
t10 xor t11; 
DATAOUT(111 downto 96) := POLY_MULTE_FUNCT("0000000000000010", t9) xor
POLY_MULTE_FUNCT("0000000000000011", t10) xor
t8 xor t11; 
DATAOUT(95 downto 80) := POLY_MULTE_FUNCT("0000000000000010", t10) xor
POLY_MULTE_FUNCT("0000000000000011", t11) xor
t8 xor t9; 
DATAOUT(79 downto 64) := POLY_MULTE_FUNCT("0000000000000011", t8) xor
POLY_MULTE_FUNCT("0000000000000010", t11) xor 
t9 xor t10; 
DATAOUT(63 downto 48) := POLY_MULTE_FUNCT("0000000000000010", t12) xor
POLY_MULTE_FUNCT("0000000000000011", t13) xor
t14 xor t15; 
DATAOUT(47 downto 32) := POLY_MULTE_FUNCT("0000000000000010",t13) xor
POLY_MULTE_FUNCT("0000000000000011",t14) xor
t12 xor t15; 
DATAOUT(31 downto 16) := POLY_MULTE_FUNCT("0000000000000010", t14) xor
POLY_MULTE_FUNCT("0000000000000011", t15) xor
t12 xor t13; 
DATAOUT(15 downto 0) := POLY_MULTE_FUNCT("0000000000000011", t12) xor
POLY_MULTE_FUNCT("0000000000000010", t15) xor
t13 xor t14; 
temp:=DATAOUT; 
return temp; 
end function MIX_COLUMN_FUNCT; 
function POLY_MULTE_FUNCT (a: SLV_16 ; b : SLV_16 ) return SLV_16 is
variable temp : SLV_16; 
variable temp1 : SLV_16; 
variable temp2 : SLV_16; 
variable temp3 : SLV_16; 
variable and_mask : SLV_8; 
begin 
and_mask := b(7) & b(7) & b(7) & b(7) & b(7) & b(7) & b(7) & b(7); 
case a(3 downto 0) is
when "0001" => temp := b; 
when "0010" =>temp := b(15 downto 0) & '0' xor (("00011011") 
and and_mask); 
when "0011"=> temp := b(15 downto 0) & '0' xor (("00011011") 
and and_mask) xor b; 
when others => temp := (others => '0'); 
end case; 
return temp; 
end function POLY_MULTE_FUNCT; 
end package body rijndael_package1;